dnl
dnl  The Natto View
dnl
dnl  Copyright (c) 1995-1997  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
dnl
dnl  This library is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU *Library* General Public
dnl  License as published by the Free Software Foundation; either
dnl  version 2 of the License, or (at your option) any later version.
dnl

AC_DEFUN(NV_PATH_LIBWWW, [
AC_MSG_CHECKING(for libwww)
AC_CACHE_VAL(ac_cv_path_libwww, [
cwd=`pwd`
echo
LIBWWWPATH="$LIBWWWPATH ${cwd}/*libwww* ${cwd}/../*libwww* ${cwd}/../../*libwww* ${cwd}/../../../*libwww*"
for ac_dir in $LIBWWWPATH ; do
  if test -f ${ac_dir}/Library/src/WWWLib.h; then
    echo $ac_n "Use libwww in $ac_dir? (y/n) $ac_c"
    read yesno
    if test "$yesno" = "y" -o "$yesno" = ""; then
        ac_cv_path_libwww=${ac_dir}
        break
    fi
  fi
done])
ac_path_libwww=$ac_cv_path_libwww
test -z "$ac_path_libwww" && ac_path_libwww=missing
AC_MSG_RESULT($ac_path_libwww)
if test -n "$ac_cv_path_libwww"; then
  CPPFLAGS="$CPPFLAGS -I${ac_path_libwww}/Library/src"
  LIBS="$LIBS -L${ac_path_libwww}/Library/src"
fi])


AC_DEFUN(NV_PATH_STLPORT2, [
AC_MSG_CHECKING(for stlport2)
AC_CACHE_VAL(ac_cv_path_stlport2, [
cwd=`pwd`
echo
STLPORT2PATH="$STLPORT2PATH ${cwd}/*stl* ${cwd}/../*stl* ${cwd}/../../*stl* ${cwd}/../../../*stl*"
for ac_dir in $STLPORT2PATH ; do
  if test -f ${ac_dir}/stlconf.h; then
    echo $ac_n "Use STL in $ac_dir? (y/n) $ac_c"
    read yesno
    if test "$yesno" = "y" -o "$yesno" = ""; then
        ac_cv_path_stlport2=${ac_dir}
        break
    fi
  fi
done])
ac_path_stlport2=$ac_cv_path_stlport2
test -z "$ac_path_stlport2" && ac_path_stlport2=missing
AC_MSG_RESULT($ac_path_stlport2)
if test -n "$ac_cv_path_stlport2"; then
  CPPFLAGS="$CPPFLAGS -I${ac_path_stlport2}"
fi])


AC_DEFUN(NV_PROG_EGCS, [
AC_MSG_CHECKING(whether we are using Cygnus egcs g++)
AC_CACHE_VAL(ac_cv_egcs, [
if test -n "`g++ --version | grep egcs`"; then
  ac_cv_egcs="yes"
else
  ac_cv_egcs="no"
fi])
ac_egcs=$ac_cv_egcs
AC_MSG_RESULT($ac_egcs)
if test "$ac_egcs" = "yes"; then
  CPPFLAGS="$CPPFLAGS -DEGCS"
fi])


AC_DEFUN(NV_PATH_XMHTML, [
AC_MSG_CHECKING(for XmHTML)
AC_CACHE_VAL(ac_cv_path_xmhtml, [
cwd=`pwd`
echo
XMHTMLPATH="$XMHTMLPATH ${cwd}/XmHTML-* ${cwd}/../XmHTML-* ${cwd}/../../XmHTML-* ${cwd}/../../../XmHTML-*"
for ac_dir in $XMHTMLPATH ; do
  if test -f ${ac_dir}/include/XmHTML/XmHTML.h; then
    echo $ac_n "Use XmHTML in $ac_dir? (y/n) $ac_c"
    read yesno
    if test "$yesno" = "y" -o "$yesno" = ""; then
        ac_cv_path_xmhtml=${ac_dir}
        break
    fi
  fi
done])
ac_path_xmhtml=$ac_cv_path_xmhtml
test -z "$ac_path_xmhtml" && ac_path_xmhtml=missing
AC_MSG_RESULT($ac_path_xmhtml)
if test -n "$ac_cv_path_xmhtml"; then
  CPPFLAGS="$CPPFLAGS -I${ac_path_xmhtml}/include"
  LIBS="$LIBS -L${ac_path_xmhtml}/src"
fi])
