/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1996-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//                           Takahiro Souma <souma@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifdef __GNUG__
#pragma implementation
int dummy_GenericMapperBox_cc = 0;
#endif

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "GenericMapperBox.h"


GenericMapperBox::GenericMapperBox(
    const char*    name,
    GuiObject*     parent,
    GenericMapper* mapper):
    GuiObject(name, parent), mapper_(mapper)
{}


GenericMapperBox_if*
GenericMapperBox::interface()
{
    return DCAST(GenericMapperBox_if*, imp()->interface());
}


void
GenericMapperBox::create(
    GuiConfig* config)
{
    GuiObject::create(&PortKit::create_GenericMapperBox, config);
}


void
GenericMapperBox::popup(
    Natto* natto)
{
    memcpy(working_mapping_, mapper()->mapping(), sizeof(backup_mapping_));
    memcpy(backup_mapping_,  mapper()->mapping(), sizeof(backup_mapping_));
    interface()->popup(natto);
}


void
GenericMapperBox::ok(
    Natto* natto)
{
    mapper()->mapping(working_mapping_);
    mapper()->set_title();
    mapper()->layout_all(natto);
    this->popdown();
}


void
GenericMapperBox::cancel(
    Natto* natto)
{
    mapper()->mapping(backup_mapping_);
    mapper()->set_title();
    mapper()->layout_all(natto);
    this->popdown();
}


void
GenericMapperBox::apply(
    Natto* natto)
{
    mapper()->mapping(working_mapping_);
    mapper()->set_title();
    mapper()->layout_all(natto);
}


GenericMapperBox_if::~GenericMapperBox_if()
{}
