/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef GENERICMAPPERBOX_H
#define GENERICMAPPERBOX_H
#ifdef __GNUG__
#pragma interface
#endif

#include "PortKit.h"
#include "GenericMapper.h"

class Natto;
class GenericMapperBox_if;


class GenericMapperBox_if: public GuiObject_if
{
 public:
    virtual ~GenericMapperBox_if();

    virtual void popup(Natto*) = 0;
    virtual void popdown()   = 0;
    DBG_NEW
};


class GenericMapperBox: public GuiObject
{
 public:
    enum {
	n_dimensions = GenericMapper::n_dimensions,
        n_parameters = GenericMapper::n_parameters };

    GenericMapperBox(const char*, GuiObject*, GenericMapper*);

    // as GuiObject
    virtual GenericMapperBox_if* interface();
    virtual void                 create(GuiConfig*);

    // operations
    virtual void popup(Natto*);
    virtual void popdown() { interface()->popdown(); }

    // callbacks
    virtual void ok(Natto*);
    virtual void cancel(Natto*);
    virtual void apply(Natto*);

    // member access
    GenericMapper* mapper() { return mapper_; }

    GenericMapper::parameter_t working_mapping_[n_parameters];
    GenericMapper::parameter_t backup_mapping_[n_parameters];

 private:
    GenericMapper* mapper_;

    GenericMapperBox(const GenericMapperBox&);
    GenericMapperBox& operator=(const GenericMapperBox&);
    DBG_NEW
};

#endif /* GENERICMAPPERBOX_H */
