/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1996-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifdef __GNUG__
#pragma implementation
int dummy_Mapper_cc = 0;
#endif

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "Mapper.h"


Mapper::Mapper(
    string x_title,
    string y_title):
    x_title_(x_title), y_title_(y_title),
    z_step_(0.25), def_radius_(0.01)
{}


Mapper::~Mapper()
{}


void
Mapper::configure(Natto*, GuiObject*)
{}


void
Mapper::layout_all(
    Natto* natto)
{
    for (Natto::node_iter i = natto->nodes_begin();
         i != natto->nodes_end(); i++) {
	this->layout(natto, *i);
	(*i)->set_flags(Natto::shape_changed_bit);
    }
    natto->sync();
}
