/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1996-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef MAPPER_H
#define MAPPER_H
#ifdef __GNUG__
#pragma interface
#endif

#include "Natto.h"

class GuiObject;


class Mapper
{
 public:
    Mapper(string x_title, string y_title);
    virtual ~Mapper();

    virtual void   configure(Natto*, GuiObject*);
    virtual void   layout(Natto*, Natto::node*) = 0;
    virtual void   layout_all(Natto*);
    virtual bool   x_label(Natto*, int, float&, string&) = 0;
    virtual bool   y_label(Natto*, int, float&, string&) = 0;
    float   z_step()     const { return z_step_; }
    float   def_radius() const { return def_radius_; }
    
    string x_title() const { return x_title_; }
    string y_title() const { return y_title_; }
    void   x_title(string t) { x_title_ = t; }
    void   y_title(string t) { y_title_ = t; }

 private:
    string x_title_;
    string y_title_;
    float  z_step_;
    float  def_radius_;
    DBG_NEW
};

#endif /* MAPPER_H */
