/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifdef __GNUG__
#pragma implementation
int dummy_SiteBar_cc = 0;
#endif

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "SiteBar.h"
#include "MainFrame.h"


SiteBar::SiteBar(
    const char* name,
    GuiObject*  parent,
    MainFrame*  frame):
    GuiObject(name, parent), frame_(frame)
{}


SiteBar_if*
SiteBar::interface()
{
    return DCAST(SiteBar_if*, imp()->interface());
}


void
SiteBar::create(
    GuiConfig* config)
{
    GuiObject::create(&PortKit::create_SiteBar, config);
}


void
SiteBar::browse()
{
    frame_->browse();
}


void
SiteBar::focus(
    URL url)
{
    frame_->focus_node(url);
}


SiteBar_if::~SiteBar_if()
{}
