/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef SITEBAR_H
#define SITEBAR_H
#ifdef __GNUG__
#pragma interface
#endif

#include "PortKit.h"
#include "Natto.h"


class SiteBar_if: public GuiObject_if
{
 public:
    virtual ~SiteBar_if();

    virtual void set_node(Natto::node*) = 0;
    DBG_NEW
};


class SiteBar: public GuiObject
{
 public:
    SiteBar(const char* name, GuiObject* parent, MainFrame* frame);

    // as GuiObject
    virtual SiteBar_if* interface();
    virtual void        create(GuiConfig*);

    // operations
    virtual void set_node(Natto::node* vp) { interface()->set_node(vp); }
    virtual void browse();
    virtual void focus(URL);

 private:
    MainFrame* frame_;

    SiteBar(const SiteBar&);
    SiteBar& operator=(const SiteBar&);
    DBG_NEW
};

#endif /* SITEBAR_H */
