/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1996-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef SPRINGMAPPER_H
#define SPRINGMAPPER_H
#ifdef __GNUG__
#pragma interface
#endif

#include "Mapper.h"


class SpringMapper: public Mapper
{
 public:
    enum dim_t { dim_x = 01, dim_y = 02, dim_z = 04 };

    explicit SpringMapper(int dimensions);
    virtual void layout(Natto*, Natto::node*);
    virtual void layout_all(Natto*);
    virtual bool x_label(Natto*, int, float&, string&);
    virtual bool y_label(Natto*, int, float&, string&);

 protected:
    double alpha(int iter);
    void   distance(const Natto::node* vp, const Natto::node* up,
		    double& r, double& rx, double& ry);
    void   distance(const Natto::node* vp, const Natto::node* up,
		    double& r, double& rx, double& ry, double& rz);
    void   simulate(int max_iter, Natto* natto, Natto::node* vp = NULL);

 private:
    int    dim_;
    double epsilon;
    double L;
    double K;
    double kqq;
    size_t nodes_size_;
    DBG_NEW
};

#endif /* SPRINGMAPPER_H */
