/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef STATUSBAR_H
#define STATUSBAR_H
#ifdef __GNUG__
#pragma interface
#endif

#include <iostream.h>
#include <strstream.h>
#include "PortKit.h"
#include "Natto.h"


class StatusBar_if: public GuiObject_if
{
 public:
    virtual ~StatusBar_if();
    virtual void message(string) = 0;
    virtual void natto_size(Natto*) = 0;
    DBG_NEW
};


class StatusBar: public GuiObject
{
 public:
    StatusBar(const char* name, GuiObject* parent);
    virtual ~StatusBar();

    virtual StatusBar_if* interface();

    virtual void create(GuiConfig*);
    virtual void message(string);
    virtual void natto_size(Natto*);

 private:
    streambuf* old_rdbuf_;

    StatusBar(const StatusBar&);
    StatusBar& operator=(const StatusBar&);
    DBG_NEW
};


class StatusBarBuf: public streambuf
{
 public:
    explicit StatusBarBuf(StatusBar*);
    ~StatusBarBuf();

    int sync();
    int overflow(int);
    streamsize xsputn(char*, streamsize);

 private:
    StatusBar* statbar_;
    strstream* tempbuf_;

    StatusBarBuf(const StatusBarBuf&);
    StatusBarBuf& operator=(const StatusBarBuf&);
    DBG_NEW
};

#endif /* STATUSBAR_H */
