/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifdef __GNUG__
#pragma implementation
int dummy_ToolBar_cc = 0;
#endif

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "ToolBar.h"
#include "MainFrame.h"


ToolBar::ToolBar(
    const char* name,
    GuiObject*  parent,
    MainFrame*  frame):
    GuiObject(name, parent), frame_(frame)
{}


ToolBar_if*
ToolBar::interface()
{
    return DCAST(ToolBar_if*, imp()->interface());
}


void
ToolBar::create(
    GuiConfig* config)
{
    GuiObject::create(&PortKit::create_ToolBar, config);
}


void
ToolBar::browse()
{
    frame_->browse();
}


void
ToolBar::reload()
{
    frame_->scan();
}


void
ToolBar::stop()
{
    frame_->stop_transfer();
}


ToolBar_if::~ToolBar_if()
{}
