/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef TOOLBAR_H
#define TOOLBAR_H
#ifdef __GNUG__
#pragma interface
#endif

#include "PortKit.h"
#include "Natto.h"


class ToolBar_if: public GuiObject_if
{
 public:
    virtual ~ToolBar_if();
    DBG_NEW
};


class ToolBar: public GuiObject
{
 public:
    ToolBar(const char* name, GuiObject* parent, MainFrame* frame);

    // as GuiObject
    virtual ToolBar_if* interface();
    virtual void        create(GuiConfig*);

    // operations
    virtual void browse();
    virtual void reload();
    virtual void stop();

 private:
    MainFrame* frame_;

    ToolBar(const ToolBar&);
    ToolBar& operator=(const ToolBar&);
    DBG_NEW
};

#endif /* TOOLBAR_H */
