/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef VIEWPALETTE_H
#define VIEWPALETTE_H
#ifdef __GNUG__
#pragma interface
#endif

#include "PortKit.h"
#include "Natto.h"


class ViewPalette_if: public GuiObject_if
{
 public:
    virtual ~ViewPalette_if();
    virtual void set_render_mode() = 0;
    DBG_NEW
};


class ViewPalette: public GuiObject
{
 public:
    ViewPalette(const char* name, GuiObject* parent);

    // as GuiObject
    virtual ViewPalette_if* interface();
    virtual void create(GuiConfig*);

    // callbacks
    virtual void lift_up();
    virtual void lift_down();
    virtual void lift_down_all();
    virtual void home_view();
    virtual void top_view();
    virtual void top_view_2d();
    virtual void zoom_in();
    virtual void zoom_out();
    virtual void wireframe(bool);
    virtual bool wireframe();
    virtual void draw_icon(bool);
    virtual bool draw_icon();
    virtual void draw_label(bool);
    virtual bool draw_label();

    // member access
    NattoView*   view() { return view_; }
    virtual void view(NattoView*);

 private:
    NattoView* view_;

    ViewPalette(const ViewPalette&);
    ViewPalette& operator=(const ViewPalette&);
    DBG_NEW
};

#endif /* VIEWPALETTE_H */
