/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1995-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

// This file contains the code based on GLUT 3.1
///* Copyright (c) Mark J. Kilgard, 1994. */

#ifndef UTILGL_H
#define UTILGL_H
#ifdef __GNUG__
#pragma interface
#endif

#include <stddef.h>
#include <string>
#include <GL/gl.h>


struct PackingMode
{
    GLint swap_bytes, lsb_first, row_length;
    GLint skip_rows, skip_pixels, alignment;
};


#if 0
class SGIImage
{
    friend istream& operator>>(istream&, SGIImage&);
    friend ostream& <<(ostream&, SGIImage);
 public:
 private:
    GLushort type;
    GLushort width, height, depth;
    char name[80];
    GLubyte* data;
};
#endif

inline void v3f  (GLfloat x, GLfloat y, GLfloat z) { glVertex3f(x, y, z); }
inline void v3fv (GLfloat v[3]) { glVertex3fv(v); }
inline void n3f  (GLfloat x, GLfloat y, GLfloat z) { glNormal3f(x, y, z); }
inline void n3fv (GLfloat v[3]) { glNormal3fv(v); }
inline void c3f  (GLfloat r, GLfloat g, GLfloat b) { glColor3f(r, g, b); }
inline void c3fv (GLfloat c[3]) { glColor3fv(c); }
inline void c3ub (GLubyte r, GLubyte g, GLubyte b) { glColor3ub(r, g, b); }
inline void c3ubv(GLubyte c[3]) { glColor3ubv(c); }
inline void c4f  (GLfloat r, GLfloat g, GLfloat b, GLfloat a) { glColor4f(r, g, b, a); }
inline void c4fv (GLfloat c[4]) { glColor4fv(c); }
inline void ClearColor(GLfloat c[4]) { glClearColor(c[0], c[1], c[2], c[3]); }

void  GetUnpackingMode(PackingMode&);
void  SetUnpackingMode(PackingMode&);
void* LoadSGIImage(istream& in, GLint& width, GLint& height);
void* GrabWindowImage(GLint& width, GLint& height);

void WireSphere (GLfloat r, GLint slices = 16, GLint stacks = 16);
void SolidSphere(GLfloat r, GLint slices = 16, GLint stacks = 16);
void WireSphere_icosahedron (GLfloat r, int depth = 0);
void SolidSphere_icosahedron(GLfloat r, int depth = 0);
void WireCube (GLfloat size);
void SolidCube(GLfloat size);

void StrokeText(GLfloat x, GLfloat y, GLfloat z, GLfloat angle, GLfloat zoom,
		string str, size_t len = 0);

//////////////////////////////////////////////////////////////////////////////
//  The following structures are taken from glut_stroke.c in GLUT 3.1
//
///* Copyright (c) Mark J. Kilgard, 1994. */
//
///* This program is freely distributable without licensing fees 
//   and is provided without guarantee or warrantee expressed or 
//   implied. This program is -not- in the public domain. */

typedef struct {
    float x;
    float y;
} CoordRec, *CoordPtr;

typedef struct {
    int num_coords;
    CoordPtr coord;
} StrokeRec, *StrokePtr;

typedef struct {
    int num_strokes;
    StrokePtr stroke;
    float center;
    float right;
} StrokeCharRec, *StrokeCharPtr;

typedef struct {
    char *name;
    int num_chars;
    StrokeCharPtr ch;
    float top;
    float bottom;
} StrokeFontRec, *StrokeFontPtr;

//////////////////////////////////////////////////////////////////////////////


void StrokeCharacter(StrokeFontPtr fontinfo, int c);

extern StrokeFontRec StrokeRoman;
extern StrokeFontRec StrokeMonoRoman;

#endif /* GLEX_H */
