/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef HTML_H
#define HTML_H
#ifdef __GNUG__
#pragma interface
#endif

#include "SGML.h"


class HTML: public SGML
{
 public:
    typedef void (LinkExtractor::*start_handler)(string, attrs_type&);
    typedef void (LinkExtractor::*end_handler)(string);
    typedef map<string, start_handler, less<string> > start_handlers_type;
    typedef map<string, end_handler,   less<string> > end_handlers_type;

    HTML(textpos, size_t);
    
 protected:
    virtual void text_block(textpos, textpos);
    virtual void start_element(string, attrs_type&);
    virtual void end_element(string);

    virtual void start_head(string, attrs_type&) {}
    virtual void start_title(string, attrs_type&) {}
    virtual void start_link(string, attrs_type&) {}
    virtual void start_base(string, attrs_type&) {}
    virtual void start_body(string, attrs_type&) {}
    virtual void start_hx(string, attrs_type&) {}
    virtual void start_a(string, attrs_type&) {}
    virtual void start_img(string, attrs_type&) {}
    virtual void start_area(string, attrs_type&) {}
    virtual void start_form(string, attrs_type&) {}
    virtual void start_input(string, attrs_type&) {}
    virtual void start_frame(string, attrs_type&) {}
    virtual void start_iframe(string, attrs_type&) {}
    virtual void start_script(string, attrs_type&) {}

    virtual void end_title(string) {}
    virtual void end_hx(string) {}
    virtual void end_a(string) {}
    virtual void end_form(string) {}

    static void class_init();
    
 private:
    static bool class_initialized_;
    static start_handlers_type start_handlers_;
    static end_handlers_type   end_handlers_;
    DBG_NEW
};

#endif /* HTML_H */
