/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef NETHTTP_H
#define NETHTTP_H
#ifdef __GNUG__
#pragma interface
#endif

#include "NetManager.h"


class NetHTTP: public NetProtocol
{
 public:
    NetHTTP(NetManager*);

 protected:
    virtual void get (NetRequest&, NetResponse&);
    virtual void head(NetRequest&, NetResponse&);
    virtual void post(NetRequest&, NetResponse&);
    virtual void do_request(NetRequest&, NetResponse&, const char*);

 protected:
    struct RequestLine {
        friend class NetHTTP;
        friend ostream& operator<<(ostream&, const NetHTTP::RequestLine&);
     protected:
        RequestLine() {}
        RequestLine(string m, string p, string v):
            method(m), path(p), version(v) {}
        string method;
        string path;
        string version;
        DBG_NEW
    };

    struct ResponseLine {
        friend class NetHTTP;
        friend istream& operator>>(istream&, NetHTTP::ResponseLine&);
        friend ostream& operator<<(ostream&, const NetHTTP::ResponseLine&);
     protected:
        ResponseLine(): status(0) {}
        ResponseLine(string v, int s, string d):
            version(v), status(s), description(d) {}
        string version;
        int    status;
        string description;
        DBG_NEW
    };
    DBG_NEW
};

#endif /* NETHTTP_H */
