/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef NETLOCAL_H
#define NETLOCAL_H
#ifdef __GNUG__
#pragma interface
#endif

#include <sys/stat.h>
#include "NetManager.h"


class NetLocal: public NetProtocol
{
 public:
    NetLocal(NetManager*);

 protected:
    virtual void get(NetRequest& req, NetResponse& res);

    virtual void get_file (NetRequest& req, NetResponse& res);
    virtual void get_dir  (NetRequest& req, NetResponse& res);
    virtual void head_file(NetRequest& req, NetResponse& res);
    virtual void head_dir (NetRequest& req, NetResponse& res);
    virtual void set_stat (NetHeaders&, const struct stat&);

    DBG_NEW
};

#endif /* NETLOCAL_H */
