/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1996-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#define DBG_MODULE  URL

#ifdef __GNUG__
#pragma implementation
#endif

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "URL_news.h"

#include <strstream.h>
#include "util.h"

#if defined __GNUG__ && (defined EGCS || __GNUC__ >= 2 && __GNUC_MINOR__ >= 8)
#define remove erase
#endif


URL_news::URL_news(
    string url,
    URL    base)
{
    DBG("news", url << " (base=" << base << ") creating");

    string::size_type atmark = url.find('@');
    if (atmark != string::npos) {
        // message id
        string::size_type sharp = url.find('#');
        if (sharp != string::npos && atmark < sharp) {
            path_ = url.substr(0, sharp);
            frag_ = url.substr(sharp + 1);
        }
        else {
            path_ = url;
        }
    }
    else {
        // group name
        path_ = url;
    }
}


string
URL_news::parse(
    int bits) const
{
    string url;

    if (bits & scheme_bit) url += scheme(), url += ':';
    if (bits & path_bit)   url += path_;
    if (bits & frag_bit && frag().length())
        url += '#', url += efrag();

    DBG("news", "parsed=" << url << " (bits=" << bits << ')');
    return url;
}


string
URL_news::rel(
    URL base,
    int bits) const
{
    return this->parse(bits);
}


bool
URL_news::is_valid() const
{
    return path_.length();
}
    

string
URL_news::basename() const
{
    return path_;
}


bool
URL_mail::is_valid() const
{
    return this->messageid().length();
}
