#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
/*#include <stdio.h>*/

int mkdir2(const char* path, mode_t mode)
{
    char* dir = strdup(path);
    char* p;
    struct stat st;

    for (p = dir + (dir[0] == '/'); (p = strchr(p, '/')); p++) {
        *p = '\0';
        if (stat(dir, &st) < 0) {
            /*fputs(dir, stderr);*/
            if (mkdir(dir, mode) < 0) {
                free(dir);
                return -1;
            }
        }
        else if (!S_ISDIR(st.st_mode)) {
            errno = EEXIST;
            free(dir);
            return -1;
        }
        *p = '/';
    }
    /*fputs(dir, stderr);*/
    free(dir);
    return mkdir(path, mode);
}


#if 0
int mkpath(const char* file, mode_t mode)
{
    char* dir = strdup(path);
    char* p;
    struct stat st;

    for (p = dir + (dir[0] == '/'); (p = strchr(p, '/')); p++) {
        *p = '\0';
        if (stat(dir, &st) < 0) {
            /*fputs(dir, stderr);*/
            if (mkdir(dir, mode) < 0) {
                free(dir);
                return -1;
            }
        }
        else if (!S_ISDIR(st.st_mode)) {
            errno = EEXIST;
            free(dir);
            return -1;
        }
        *p = '/';
    }
    free(dir);
    return mkdir(path, mode);
}
#endif
