/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1996-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef NETSTREAM_H
#define NETSTREAM_H
#ifdef __GNUG__
#pragma interface
#endif

//////////////////////////////////////////////////////////////////////////////
//  netstream.h -- iostream-style socket interface
//

#include <sys/types.h>
#include <fstream.h>
#include <string>
#include <netinet/in.h>
#include "utilstl.h"


//////////////////////////////////////////////////////////////////////////////
//  netstream -- fstream wrapper for socket
//
class netstream: public fstream
{
 public:
    netstream();
    netstream(string rhost, u_short rport);
    netstream(string rhost, string service);

    void open(string rhost, u_short rport);
    void open(string rhost, string service);

 protected:
    static bool dns_query(string, struct in_addr&);
    
 private:
    typedef hmap<string, struct in_addr> dns_cache_type;
    static dns_cache_type dns_cache_;
    
    void open(const char *name, int mode, int prot);
    DBG_NEW
};

#endif /* NETSTREAM_H */
