/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifdef __GNUG__
#pragma implementation
int dummy_observer_cc = 0;
#endif

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "observer.h"


#ifdef __GNUG__
#pragma implementation
#endif

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "observer.h"

#include <algorithm>


observer::~observer()
{}


observable::observable():
    changed_(false)
{}


observable::~observable()
{}

    
void
observable::attach(
    observer* v)
{
    if (find(observers_.begin(), observers_.end(), v) == observers_.end()) 
	observers_.push_back(v);
}


void    
observable::detach(
    observer* v)
{
    observer_vector::iterator i =
	find(observers_.begin(), observers_.end(), v);
    if (i != observers_.end()) observers_.erase(i);
}
    

void
observable::notify(
    int   priority,
    void* data)
{
    if (!changed_) return;
    for (observer_vector::reverse_iterator i = observers_.rbegin();
	 i != observers_.rend(); i++)
	(*i)->update(this, priority, data);
    changed_ = false;
}
