/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1996-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef OBSERVER_H
#define OBSERVER_H
#ifdef __GNUG__
#pragma interface
#endif

//////////////////////////////////////////////////////////////////////////////
//  Model/View (Observer) tool
//

//#include "ptrvector.h"
#include <vector>

class observable;


//////////////////////////////////////////////////////////////////////////////
//  observer -- 
//
class observer
{
 public:
    virtual ~observer();
    virtual void update(observable* from, int priority, void* data) = 0;
    DBG_NEW
};


//////////////////////////////////////////////////////////////////////////////
//  observable -- 
//
class observable
{
 public:
    //typedef ptrvector<observer*> observer_vector;
    typedef vector<observer*> observer_vector;

    observable();
    virtual ~observable();
    
    virtual void attach(observer*);
    virtual void detach(observer*);
    virtual void notify(int priority, void* data);
    virtual bool changed() const { return changed_; }
    
 protected:
    virtual void changed(bool f) { changed_ = f; }
    
 private:
    bool            changed_;
    observer_vector observers_;

    observable(const observable&);
    observable& operator=(const observable&);
    DBG_NEW
};

#endif /* OBSERVER */
