/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef PIPESTREAM_H
#define PIPESTREAM_H
#ifdef __GNUG__
#pragma interface
#endif

//////////////////////////////////////////////////////////////////////////////
//  pipestream.h -- iostream-style stream pipe interface
//

#include <sys/types.h>
#include <fstream.h>


//////////////////////////////////////////////////////////////////////////////
//  pipestream -- fstream wrapper for pipe
//
class pipestream: public fstream
{
 public:
    pipestream();
    pipestream(int fd);
    pipestream(const char* file, char* const argv[]);
    void open(const char* file, char* const argv[]);
    void open_execvp(const char* file, char* const argv[]);
    void open_execv(const char* path, char* const argv[]);
    DBG_NEW
};

#endif /* PIPESTREAM_H */
