class refcnt_rep
{
    friend class refcnt;
    
 public:
    refcnt_rep(): ref_(0) {}
    virtual ~refcnt_rep() {}

    int ref() const { return ref_; }

 protected:
    virtual void grab()    { ref_++; }
    virtual void release() { if (!--ref_) delete this; }
    virtual refcnt_rep* clone() const = 0;
    
 private:
    int ref_;
    DBG_NEW
};


class refcnt
{
 public:
    explicit refcnt(const refcnt_rep* rep): rep_(rep) { rep_->grab(); }
    refcnt(const refcnt& x): rep_(x.rep_) { rep_->grab(); }    
    virtual ~refcnt() { rep_->release(); rep_ = NULL; }    

    refcnt& operator=(refcnt& x) {
        if (&x != this) this->set_rep(x.rep_);
        return *this;
    }

 protected:
    void set_rep(const refcnt_rep* rep) {
        if (rep_ == rep) return;
        rep_->release();
        rep_ = rep;
        rep_->grab();
    }
    
    refcnt_rep* rep() { return rep_; }
    const refcnt_rep* rep() const { return rep_; }
    
 private:
    mutable refcnt_rep* rep_;
    DBG_NEW
};
