/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1996-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef ANCHORBOX_XM_H
#define ANCHORBOX_XM_H
#ifdef __GNUG__
#pragma interface
#endif

#include <Xm/Xm.h>
#include "AnchorBox.h"
#include "MotifKit.h"



//////////////////////////////////////////////////////////////////////////////
//  AnchorBox_Xm -- 
//
class AnchorBox_Xm: public GuiObject_Xm, public AnchorBox_if
{
    typedef AnchorBox_Xm self_type;

 public:
    explicit AnchorBox_Xm(GuiObject*);

    virtual void          init(GuiConfig*);
    virtual AnchorBox*    obj();
    virtual GuiObject_if* interface();

    virtual void popup();
    virtual void popdown();
    virtual void clear();
    virtual void highlight(int);
    virtual void unhighlight();
    virtual void set_node(Natto::node*);
    virtual void set_title(string);

 protected:
    virtual void delayed_init();

    DeclCallback(shell_destroy,   XtPointer);
    DeclCallback(list_action,     XmListCallbackStruct*);
    DeclCallback(list_selection,  XmListCallbackStruct*);
    DeclCallback(focus_activate,  XtPointer);
    DeclCallback(browse_activate, XtPointer);
    DeclCallback(scan_activate,   XtPointer);
    DeclCallback(tour_activate,   XtPointer);
    DeclCallback(close_activate,  XtPointer);
    
 private:
    MotifConfig          config_;
    Widget               list_;
    Widget               btnbar_;
    vector<Natto::link*> items_;
    Natto::node*         prev_node_;

    AnchorBox_Xm(const AnchorBox_Xm&);
    AnchorBox_Xm& operator=(const AnchorBox_Xm&);
    DBG_NEW
};

#endif /* ANCHORBOX_XM_H */
