/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef GENERICMAPPERBOX_XM_H
#define GENERICMAPPERBOX_XM_H
#ifdef __GNUG__
#pragma interface
#endif

#include <X11/Intrinsic.h>
#include "GenericMapperBox.h"
#include "MotifKit.h"
#include "MainFrame.h"


class GenericMapperBox_Xm: public GuiObject_Xm, public GenericMapperBox_if
{
    typedef GenericMapperBox_Xm self_type;

 public:
    enum {
	n_dimensions = GenericMapper::n_dimensions,
        n_parameters = GenericMapper::n_parameters
    };
    typedef GenericMapper::dimension_t dimension_t;

    explicit GenericMapperBox_Xm(GuiObject*);

    virtual void              init(GuiConfig*);
    virtual GenericMapperBox* obj();
    virtual GuiObject_if*     interface();

    virtual void popup(Natto*);
    virtual void popdown();

 protected:
    virtual void delayed_init();
    virtual void create_opmenu(Widget, int);

    DeclCallback(shell_destroy,   XtPointer);
    DeclCallback(ok_activate,     XtPointer);
    DeclCallback(apply_activate,  XtPointer);
    DeclCallback(cancel_activate, XtPointer);
    DeclCallback(opmenu_activate, XtPointer);

 private:
    MotifConfig config_;
    Natto*      natto_;
    Widget      op_menu[n_dimensions];
    Widget      op_btn[n_dimensions][n_parameters];

    GenericMapperBox_Xm(const GenericMapperBox_Xm&);
    GenericMapperBox_Xm& operator=(const GenericMapperBox_Xm&);
    DBG_NEW
};

#endif /* GENERICMAPPERBOX_XM_H */
