/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1996-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef MAINFRAME_XM_H
#define MAINFRAME_XM_H
#ifdef __GNUG__
#pragma interface
#endif

#include <Xm/Xm.h>
#include "xtinter.h"
#include "MainFrame.h"
#include "MotifKit.h"


//////////////////////////////////////////////////////////////////////////////
//  MainFrame_Xm -- 
//
class MainFrame_Xm: public GuiObject_Xm, public MainFrame_if
{
    typedef MainFrame_Xm self_type;

 public:
    explicit MainFrame_Xm(GuiObject*);

    void          init(GuiConfig*);
    MainFrame*    obj();
    GuiObject_if* interface();

    virtual void set_title(string);
    virtual void mozilla_open(URL);

    // member access
    XtAppContext app_context()
	{ return XtWidgetToApplicationContext(this->widget());}
    Colormap colormap() { return cmap_; }

 protected:
    // Motif callback interface
    DeclCallback(menubar_load,           XtPointer);
    DeclCallback(menubar_save,           XtPointer);
    DeclCallback(menubar_quit,           XtPointer);
    DeclCallback(menubar_about,          XtPointer);
    DeclCallback(menubar_generic_mapper, XtPointer);
    DeclCallback(menubar_spring_mapper,  XtPointer);
    DeclCallback(menubar_anchorbox,      XtPointer);
    DeclCallback(menubar_tourbox,        XtPointer);
    DeclCallback(menubar_mapperbox,      XtPointer);
    DeclCallback(menubar_import_icon,    XtPointer);

    DeclCallback(savebox_ok,     XmFileSelectionBoxCallbackStruct*);
    DeclCallback(savebox_cancel, XmFileSelectionBoxCallbackStruct*);
    DeclCallback(loadbox_ok,     XmFileSelectionBoxCallbackStruct*);
    DeclCallback(loadbox_cancel, XmFileSelectionBoxCallbackStruct*);
#if 0
    DeclCallback(file_search, XmFileSelectionBoxCallbackStruct*);
#endif

 private:
    Widget menubar_;
    Widget savebox_;
    Widget loadbox_;
    Widget aboutbox_;
    Colormap cmap_;

    MainFrame_Xm(const MainFrame_Xm&);
    MainFrame_Xm& operator=(const MainFrame_Xm&);
    DBG_NEW
};

#endif /* MAINFRAME_XM_H */
