/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1996-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef SITEBAR_XM_H
#define SITEBAR_XM_H
#ifdef __GNUG__
#pragma interface
#endif

#include <Xm/Xm.h>
#include "SiteBar.h"
#include "MotifKit.h"


class SiteBar_Xm: public GuiObject_Xm, public SiteBar_if
{
    typedef SiteBar_Xm self_type;

 public:
    explicit SiteBar_Xm(GuiObject*);
    virtual ~SiteBar_Xm();

    virtual void          init(GuiConfig*);
    virtual SiteBar*      obj();
    virtual GuiObject_if* interface();

    virtual void set_node(Natto::node*);

 protected:
    DeclCallback(sitebox_activate,     XtPointer);
    DeclCallback(sitebox_selection,    XmListCallbackStruct*);
    DeclCallback(sitebox_focus,        XtPointer);
    DeclCallback(sitebox_losing_focus, XtPointer);
    DeclCallback(browse_activate,      XtPointer);
	    
 private:
    Widget sitebox_;
    Pixmap browse_pixmap_;

    SiteBar_Xm(const SiteBar&);
    SiteBar_Xm& operator=(const SiteBar&);
    DBG_NEW
};

#endif /* SITEBAR_XM_H */

