/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifdef __GNUG__
#pragma implementation
int dummy_StatusBar_Xm_cc = 0;
#endif

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "StatusBar_Xm.h"

#include <Xm/XmAll.h>


StatusBar_Xm::StatusBar_Xm(
    GuiObject* obj):
    GuiObject_Xm(obj)
{}


void
StatusBar_Xm::init(
    GuiConfig* config)
{
    MotifConfig conf;
    if (config) conf = *DCAST(MotifConfig*, config);

    GuiObject_Xm* parent = DCAST(GuiObject_Xm*, obj()->parent()->imp());
    this->widget(XmCreateForm(parent->widget(), obj()->name(),
                              conf.args(), conf.size()));

    conf.clear();
    conf.add(XmNeditable,              False)
        .add(XmNtraversalOn,           False)
        .add(XmNcursorPositionVisible, False)
        .add(XmNresizeHeight,          True)
        .add(XmNtopAttachment,         XmATTACH_FORM)
        .add(XmNbottomAttachment,      XmATTACH_FORM)
        .add(XmNleftAttachment,        XmATTACH_NONE)
        .add(XmNrightAttachment,       XmATTACH_FORM);
    statbox_ =
        XmCreateTextField(widget(), "statbox", conf.args(), conf.size());
    XtManageChild(statbox_);

    conf.clear();
    conf.add(XmNeditable,              False)
        .add(XmNtraversalOn,           False)
        .add(XmNcursorPositionVisible, False)
        .add(XmNvalue,                 "NattoView " NATTOVIEW)
        .add(XmNresizeHeight,          True)
        .add(XmNtopAttachment,         XmATTACH_FORM)
        .add(XmNbottomAttachment,      XmATTACH_FORM)
        .add(XmNleftAttachment,        XmATTACH_FORM)
        .add(XmNrightWidget,           statbox_);
    msgbar_ = XmCreateTextField(widget(), "msgbar", conf.args(), conf.size());
    XtManageChild(msgbar_);
}


StatusBar*
StatusBar_Xm::obj()
{
    return DCAST(StatusBar*, GuiObject_imp::obj());
}


GuiObject_if*
StatusBar_Xm::interface()
{
    return this;
}


void
StatusBar_Xm::message(
    string msg)
{
    XmTextFieldSetString(msgbar_, msg.c_str());
}


void
StatusBar_Xm::natto_size(
    Natto* natto)
{
    strstream buf;
    buf << natto->nodes_size() << " : " << natto->links_size() << ends;
    XmTextSetString(statbox_, buf.str());
    buf.freeze(false);
}
