/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef STATUS_XM_H
#define STATUS_XM_H
#ifdef __GNUG__
#pragma interface
#endif

#include <Xm/Xm.h>
#include "StatusBar.h"
#include "MotifKit.h"


class StatusBar_Xm: public GuiObject_Xm, public StatusBar_if
{
    typedef StatusBar_Xm self_type;

 public:
    explicit StatusBar_Xm(GuiObject*);

    virtual void          init(GuiConfig*);
    virtual StatusBar*    obj();
    virtual GuiObject_if* interface();

    virtual void message(string);
    virtual void natto_size(Natto*);

 private:
    Widget msgbar_;
    Widget statbox_;

    StatusBar_Xm(const StatusBar_Xm&);
    StatusBar_Xm& operator=(const StatusBar_Xm&);
    DBG_NEW
};

#endif /* STATUS_XM_H */

