/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef TOOLBAR_XM_H
#define TOOLBAR_XM_H
#ifdef __GNUG__
#pragma interface
#endif

#include <Xm/Xm.h>
#include "ToolBar.h"
#include "MotifKit.h"


class ToolBar_Xm: public GuiObject_Xm, public ToolBar_if
{
    typedef ToolBar_Xm self_type;

 public:
    explicit ToolBar_Xm(GuiObject*);
    virtual ~ToolBar_Xm();

    virtual void          init(GuiConfig*);
    virtual ToolBar*      obj();
    virtual GuiObject_if* interface();

 protected:
    DeclCallback(browse_activate, XtPointer);
    DeclCallback(reload_activate, XtPointer);
    DeclCallback(stop_activate,   XtPointer);
	    
 private:
    Pixmap browse_pixmap_;
    Pixmap reload_pixmap_;
    Pixmap stop_pixmap_;

    ToolBar_Xm(const ToolBar_Xm&);
    ToolBar_Xm& operator=(const ToolBar_Xm&);
    DBG_NEW
};

#endif /* TOOLBAR_XM_H */

