/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef TOURBOX_XM_H
#define TOURBOX_XM_H
#ifdef __GNUG__
#pragma interface
#endif

#include <Xm/List.h>
#include "TourBox.h"
#include "MotifKit.h"


//////////////////////////////////////////////////////////////////////////////
//  TourBox_Xm -- 
//
class TourBox_Xm: public GuiObject_Xm, public TourBox_if
{
    typedef TourBox_Xm self_type;

 public:
    explicit TourBox_Xm(GuiObject*);

    virtual void          init(GuiConfig*);
    virtual TourBox*      obj();
    virtual GuiObject_if* interface();

    virtual void popup();
    virtual void popdown();
    virtual void clear();
    virtual void highlight(int);
    virtual void unhighlight();
    virtual void set_title(string);
    virtual void make_listing(int);

 protected:
    virtual void delayed_init();

    DeclCallback(shell_destroy,   XtPointer);
    DeclCallback(list_action,     XmListCallbackStruct*);
    DeclCallback(list_selection,  XmListCallbackStruct*);
    DeclCallback(browse_activate, XtPointer);
    DeclCallback(scan_activate,   XtPointer);
    DeclCallback(tour_activate,   XtPointer);
    DeclCallback(update_activate, XtPointer);
    DeclCallback(close_activate,  XtPointer);
    
 private:
    MotifConfig          config_;
    Widget               list_;
    Widget               btnbar_;
    vector<Natto::node*> items_;

    TourBox_Xm(const TourBox_Xm&);
    TourBox_Xm& operator=(const TourBox_Xm&);
    DBG_NEW
};

#endif /* TOURBOX_XM_H */
