/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1997-1998  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef VIEWPALETTE_XM_H
#define VIEWPALETTE_XM_H
#ifdef __GNUG__
#pragma interface
#endif

#include <Xm/Xm.h>
#include "ViewPalette.h"
#include "MotifKit.h"


class ViewPalette_Xm: public GuiObject_Xm, public ViewPalette_if
{
    typedef ViewPalette_Xm self_type;

 public:
    explicit ViewPalette_Xm(GuiObject*);

    virtual void          init(GuiConfig*);
    virtual ViewPalette*  obj();
    virtual GuiObject_if* interface();

    virtual void set_render_mode();

 protected:
    DeclCallback(liftup_activate,    XtPointer);
    DeclCallback(liftdown_activate,  XtPointer);
    DeclCallback(downall_activate,   XtPointer);
    DeclCallback(homeview_activate,  XtPointer);
    DeclCallback(topview_activate,   XtPointer);
    DeclCallback(topview2d_activate, XtPointer);
    DeclCallback(zoomin_activate,    XtPointer);
    DeclCallback(zoomout_activate,   XtPointer);
    DeclCallback(wireframe_value_changed, XmToggleButtonCallbackStruct*);
    DeclCallback(drawicon_value_changed,  XmToggleButtonCallbackStruct*);
    DeclCallback(drawlabel_value_changed, XmToggleButtonCallbackStruct*);

 private:
    Widget menu_;
    Widget wireframe_;
    Widget drawicon_;
    Widget drawlabel_;

    ViewPalette_Xm(const ViewPalette_Xm&);
    ViewPalette_Xm& operator=(const ViewPalette_Xm&);
    DBG_NEW
};

#endif /* VIEWPALLETE_XM_H */
