/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1995-1997  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU *Library* General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
*/

#ifndef UTILX_H
#define UTILX_H
#ifdef __GNUG__
#pragma interface
#endif

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>

EXTERN Widget toplevel DEFAULT(= NULL);

Colormap GetShareableColormap(Display*, XVisualInfo*);
Pixmap   CreateLabelPixmap(Widget, char*[]);
int      ListGetSelectedPosFirst(Widget);
void     ScaleSetValue(Widget, int);
Widget   CreatePopupMenu2(Widget, String, ArgList, Cardinal);
void     ManagePopupMenu2(Widget, Position x, Position y);
void     DestroyPopupMenu2(Widget);
Widget   CreateCaption(Widget, String, ArgList, Cardinal);
XImage*  CreateXImageString(Display* dpy, Drawable win, XFontSet font_set,
			    const char* str, int& w, int& h, int& base_line);

#define GLEX_SGLBUF  GLX_RED_SIZE, 1, GLX_GREEN_SIZE, 1, GLX_BLUE_SIZE, 1, \
                     GLX_RGBA, GLX_DEPTH_SIZE, 16
#define GLEX_DBLBUF  GLX_RED_SIZE, 1, GLX_GREEN_SIZE, 1, GLX_BLUE_SIZE, 1, \
                     GLX_RGBA, GLX_DEPTH_SIZE, 16, GLX_DOUBLEBUFFER

void* XImageToGLBitmap(XImage* image, int width, int height);

#endif /* UTILX_H */
