/*
 *
 * Copyright (c) 1997
 * Moscow Center for SPARC Technology
 *
 * Permission to use, copy, modify, distribute and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear
 * in supporting documentation.  Moscow Center for SPARC Technology makes no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 */

// Metrowerks CodeWarrior configuration

#ifndef __STLCOMP_H
# define __STLCOMP_H
#  define __STL_USE_DEFALLOC   1
#  define __STL_UINT32_T unsigned long
#  define __STL_DEFAULT_TEMPLATE_PARAM 1
#  define __STL_STATIC_TEMPLATE_DATA 1
#  define __STL_BASE_MATCH_BUG          1
#  define __STL_UNUSED_REQUIRED_BUG     1
#  define __STL_UNINITIALIZABLE_PRIVATE  1
#  define __STL_BASE_TYPEDEF_OUTSIDE_BUG 1
#  define __STL_CONST_CONSTRUCTOR_BUG    1
// if your compiler have serious problems with typedefs, try this one
// #  define __STL_BASE_TYPEDEF_BUG          1

#  define __STL_NON_TYPE_TMPL_PARAM_BUG 1

// Metrowerks CodeWarrior
# if defined (__MWERKS__)

// Metrowerks Standard Library features begin here
// out-of-date or incorrect parameter list for some library functions
#  define __STL_MSVC50_COMPATIBILITY 1 
#  define __STL_BAD_ALLOC_DEFINED  1                                   
#  define __STL_USE_NEW_STYLE_HEADERS 1
#  define __STL_NEW_HEADER_NAMES 1

// Compiler features begin here
#  include <ansi_parms.h>
#  if defined(__MSL_LONGLONG_SUPPORT__)
#   define __STL_LONG_LONG 
#  endif
#   define __STL_EXPLICIT 1
#   define __STL_EXCEPTIONS 1

#   define __STL_NO_NAMESPACES 1                                                                
#   define __STL_MUTABLE 1
#   define __STL_NEW_STYLE_CASTS 1
#   define __STL_IOSFWD 1

#  if __MWERKS__ >= 0x1900         				// dwa 8/19/97 - 1.9 Compiler feature defines
#   define __STL_BOOL_KEYWORD	1
#   define __EDG_SWITCHES	1
#   define __EXCEPTIONS	        1
#   define  __STL_NON_TYPE_TMPL_PARAM_BUG	1	// dwa 8/21/97 - this bug still present.
#   undef __STL_METHOD_SPECIALIZATION			// dwa 8/21/97 - not supported as far as I can tell
#  elif __MWERKS__ >= 0x1800                    // dwa 8/19/97 - 1.8 Compiler feature defines
#   define __STL_USE_NEWALLOC   1                                                       
#   define __STL_BOOL_KEYWORD 1                                                 
#   define __STL_BASE_TYPEDEF_BUG        1
#   undef  __STL_CONST_CONSTRUCTOR_BUG
#   define __STL_CONST_CONSTRUCTOR_BUG  1
#   undef  __STL_DEFAULT_TEMPLATE_PARAM   // default template argument can't be a template type
#   define __STL_DEFAULT_TYPE_PARAM
#  endif
# endif /* __MWERKS__ */

// common switches for EDG front-end
# if defined (__EDG_SWITCHES)
#   if defined(_TYPENAME)
#     define __STL_TYPENAME
#   endif
#   ifdef _PARTIAL_SPECIALIZATION_OF_CLASS_TEMPLATES
#     define __STL_CLASS_PARTIAL_SPECIALIZATION
#   endif
#   ifdef _MEMBER_TEMPLATES
#     define __STL_MEMBER_TEMPLATES
#   endif
#   ifdef __EXCEPTIONS
#     define __STL_USE_EXCEPTIONS
#   endif
#   undef __EDG_SWITCHES
# endif /* EDG */
#endif /* STLCOMP */